# -*- coding: UTF-8 -*-

# dictionaric-litfra-VERS
# Copyright (c) 2006 Kęstutis Biliūnas <kebil@kaunas.init.lt>
#
# This code is licensed under the GNU GPL v2

"""
OpenDict plugin for online word2word dictionary
(www.dictionaric.com)
"""

import sys
import re
import httplib
import urllib
import socket


def init(libraryPath):
    """Return dictionary instance"""

    sys.path.insert(0, libraryPath)

    return Dictionaric_litfra()



class Dictionaric_litfra:
    """WebAlkonas plugin class"""
    
    def __init__(self):
        """Initialize variables"""

        from lib import errortype, meta

        self.errorModule = errortype
        self.metaModule = meta

        self.needsList = 0
        self.encoding = "utf-8"


    def search(self, word):
        """Search for a word. Returns HTML code."""

        result = self.metaModule.SearchResult()

        try:
            self.conn = httplib.HTTPConnection("www.dictionaric.com")
            self.conn.request("GET", "/dicolithuanien/dicolithuanien.php?rech=&rech1=" \
                                  + word)		#urllib.quote(word))

            response = self.conn.getresponse()
            data = response.read()

            if ">Le terme «" in data:
                zodz = 0
            else:
                zodz = 1

            data = data[data.find("<tr><td>Lituanien"):]	#Letuvi"):]
            data = "<html><head>" \
                   "<meta http-equiv=\"Content-Type\" " \
                   "content=\"text/html; charset=utf-8\">" \
                   "</head><body><table>" + data.strip()

#            end = data.find('<center><span class="copyright">')
#            data = data[:end]

            end = data.find('<script type=')
            data = data[:end]

#            data = data.replace(">Mot Letuvi&#371;<", "><b>Mot Letuvi&#371;</b><")
#            data = data.replace(">Traduction", "><b>Traduction")
#            data = data.replace("ais)<", "ais)</b><")

            if zodz == 0:
                data = data + "<p>N&#279;ra vertimo</p>"

            data = data + "</body></html>"

            result.setTranslation(data)

        except socket.gaierror, e:
            result.setError(self.errorModule.CONNECTION_ERROR)
            return result
        
        except httplib.CannotSendRequest, e:
            result.setError(self.errorModule.CONNECTION_ERROR)
            return result

        except:
            import traceback
            traceback.print_exc()

            result.setError(self.errorModule.INTERNAL_ERROR)

            return result

        return result
